#ifndef __TEXTURE_H__
#define __TEXTURE_H__

class TextureFactory;
class Texture {
public:
	enum Format {
		RGBA8888,
		RGB888
	};
	struct Desc {
		Format format;
		unsigned width, height, bit, pitch, bufferSize;
		Desc() : width(), height(), bit(), bufferSize(), pitch(), format(RGBA8888) {}
	};

protected:
	static TextureFactory *factory;
	Desc desc;

public:
	Texture() {}
	virtual ~Texture() {}

	// eNX`t@Ngo^
	static void registerFactory(TextureFactory* fct) { factory = fct; }

		// eNX`
	static Texture *createNew(const Desc &desc, void *buffer);

	// p[^擾
	const Desc &getDesc() const { return desc; }

	// \[X擾
	virtual const void *getResource() const = 0;
};

#endif
